%include "asm_io.inc"

segment .data
    prompt_name db "What is your name? ", 0                         ; 
    prompt_count db "Enter a number between 50 and 100: ", 0        ;
    welcome_msg db "Welcome, ", 0                                   ; 
    newline db 10, 0                                                ; 
    error_msg db "Error: The number must be between 50 and 100!", 0 ; 

segment .bss
    user_name resb 50         ; 
    name_length resd 1        ; 
    print_count resd 1        ;

segment .text
global asm_main

asm_main:
    pusha                         ; 
    mov eax, prompt_name          ; 
    call print_string             ; 

    mov edi, user_name            ; 
    xor ecx, ecx                  ; 

read_name_loop:
    call read_char                ;
    cmp al, 10                    ; 
    je name_input_done            ; 
    mov [edi], al                 ; 
    inc edi                       ; 
    inc ecx                       ; 
    cmp ecx, 50                   ; 
    jl read_name_loop             ; 

    mov [name_length], ecx        ;
    mov byte [edi], 0             ; 

    mov eax, prompt_count         ; 
    call print_string             ; 
    call read_int                 ; 
    mov [print_count], eax        ; 

    ; Validate the input range
    mov eax, [print_count]        ; 
    cmp eax, 50                   ; 
    jl invalid_input              ; 
    cmp eax, 100                  ;
    jg invalid_input              ; 

    ; If input is valid, print the welcome message `print_count` times
    mov ecx, [print_count]        ; 
print_loop:
    mov eax, welcome_msg          ; 
    call print_string             ; 
    mov eax, user_name            ; 
    call print_string             ; 
    call print_nl                 ; 
    loop print_loop               ; 
    jmp exit_program              ; 

invalid_input:
    ; Print the error message
    mov eax, error_msg            ; 
    call print_string             ; 
    call print_nl                 ; 
    jmp asm_main                  ; 

    popa                          ; 
    mov eax, 0                    ; 
    ret                           ;
